/*
** HDL4SE: 软件Verilog综合仿真平台
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** LCOM: 轻量级组件对象模型
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**
** * Redistributions of source code must retain the above copyright notice,
**   this list of conditions and the following disclaimer.
** * Redistributions in binary form must reproduce the above copyright notice,
**   this list of conditions and the following disclaimer in the documentation
**   and/or other materials provided with the distribution.
** * The name of the author may be used to endorse or promote products
**   derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
** THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
* hdl4se_split4.c
  修改记录：
	202105230810: rxh, initial version
	202105241522：rxh, 增加Detector接口
*/
#include "stdlib.h" 
#include "stdio.h"
#include "string.h"
#include "object.h"
#include "dlist.h"
#include "bignumber.h"
#include "hdl4secell.h"


/* 
HDL4SE_SPLIT4
instance parameter: "32, 8, 4, 19, 9, 7, 3, 11, 1", 
   inputwidth=32
   outputwidth0=8
   outputfrom0=4
   outputwidth1=19
   outputfrom1=9
   outputwidth2=7
   outputfrom2=3
   outputwidth3=11
   outputfrom3=1
*/

#define SPLITCOUNT 4

typedef struct _sHDL4SESplit4 {
	OBJECT_HEADER
	INTERFACE_DECLARE(IHDL4SEUnit)
	HDL4SEUNIT_VARDECLARE
	INTERFACE_DECLARE(IHDL4SEDetector)
	HDL4SEDETECTOR_VARDECLARE
	DLIST_VARDECLARE
	
	IHDL4SEModule** parent;
	char* name;

	IHDL4SEUnit** in;
	int in_index;

	IBigNumber** in_data;
	IBigNumber** out_data[SPLITCOUNT];
	int out_info[SPLITCOUNT][2];

	int datavalid;
	int width;
}sHDL4SESplit4;

OBJECT_FUNCDECLARE(hdl4se_split4, CLSID_HDL4SE_SPLIT4);
HDL4SEUNIT_FUNCDECLARE(hdl4se_split4, CLSID_HDL4SE_SPLIT4, sHDL4SESplit4);
HDL4SEDETECTOR_FUNCDECLARE(hdl4se_split4, CLSID_HDL4SE_SPLIT4, sHDL4SESplit4);
DLIST_FUNCIMPL(hdl4se_split4, CLSID_HDL4SE_SPLIT4, sHDL4SESplit4);

OBJECT_FUNCIMPL(hdl4se_split4, sHDL4SESplit4, CLSID_HDL4SE_SPLIT4);

QUERYINTERFACE_BEGIN(hdl4se_split4, CLSID_HDL4SE_SPLIT4)
QUERYINTERFACE_ITEM(IID_HDL4SEUNIT, IHDL4SEUnit, sHDL4SESplit4)
QUERYINTERFACE_ITEM(IID_HDL4SEDETECTOR, IHDL4SEDetector, sHDL4SESplit4)
QUERYINTERFACE_ITEM(IID_DLIST, IDList, sHDL4SESplit4)
QUERYINTERFACE_END

static const char* hdl4se_split4ModuleInfo()
{
	return "1.0.0-20210523.0811 HDL4SE Split4 cell";
}

static int hdl4se_split4Create(const PARAMITEM* pParams, int paramcount, HOBJECT* pObject)
{
	sHDL4SESplit4* pobj;
	int i;
	pobj = (sHDL4SESplit4*)malloc(sizeof(sHDL4SESplit4));
	if (pobj == NULL)
		return -1;
	*pObject = 0;
	HDL4SEUNIT_VARINIT(pobj, CLSID_HDL4SE_SPLIT4);
	INTERFACE_INIT(IHDL4SEUnit, pobj, hdl4se_split4, hdl4se_unit);
	INTERFACE_INIT(IHDL4SEDetector, pobj, hdl4se_split4, hdl4se_detector);
	DLIST_VARINIT(pobj, hdl4se_split4);

	pobj->datavalid = 0;
	for (i = 0; i < SPLITCOUNT; i++) {
		pobj->out_data[i] = NULL;
		pobj->out_info[i][0] = 0;
		pobj->out_info[i][1] = 0;
	}
	pobj->in = NULL;
	pobj->in_data = NULL;

	
	pobj->name = NULL;
	pobj->width = 8;
	pobj->parent = NULL;

	for (i = 0; i < paramcount; i++) {
		if (pParams[i].name == PARAMID_HDL4SE_UNIT_NAME) {
			if (pobj->name != NULL)
				free(pobj->name);
			pobj->name = strdup(pParams[i].pvalue);
		} 
		else if (pParams[i].name == PARAMID_HDL4SE_UNIT_PARENT) {
			pobj->parent = (IHDL4SEModule **)pParams[i].pvalue;
		}
		else if (pParams[i].name == PARAMID_HDL4SE_UNIT_INSTANCE_PARAMETERS) {
			IBigNumber** temp = bigintegerCreate(32);
			if (temp != NULL) {
				const char* nstr;
				const char* lstr;
				int j;
				lstr = (const char*)pParams[i].pvalue;
				if (0 == objectCall3(temp, AssignStr, lstr, &nstr, 0)) {
					objectCall1(temp, GetInt32, &pobj->width);
				}
				else {
					return -1;
				}
				lstr = nstr;
				for (j = 0; j < SPLITCOUNT; j++) {
					if (0 == objectCall3(temp, AssignStr, lstr, &nstr, 0)) {
						objectCall1(temp, GetInt32, &pobj->out_info[j][0]);
					}
					else {
						return -1;
					}
					lstr = nstr;
					if (0 == objectCall3(temp, AssignStr, lstr, &nstr, 0)) {
						objectCall1(temp, GetInt32, &pobj->out_info[j][1]);
					}
					else {
						return -1;
					}
					lstr = nstr;
				}
				objectRelease(temp);
			}
		}
	}

	if (pobj->width <= 0)
		return EIID_INVALIDPARAM;
	for (i = 0; i < SPLITCOUNT; i++) {
		if (pobj->out_info[i][0] <= 0)
			return EIID_INVALIDPARAM;
		if (pobj->out_info[i][0] + pobj->out_info[i][1] > pobj->width)
			return EIID_INVALIDPARAM;
		pobj->out_data[i] = bigintegerCreate(pobj->out_info[i][0]);
	}
	pobj->in_data = bigintegerCreate(pobj->width);

	/* 返回生成的对象 */
	OBJECT_RETURN_GEN(hdl4se_split4, pobj, pObject, CLSID_HDL4SE_SPLIT4);
	return EIID_OK;
}

static void hdl4se_split4Destroy(HOBJECT object)
{
	sHDL4SESplit4* pobj;
	int i;
	pobj = (sHDL4SESplit4*)objectThis(object);
	if (pobj->name != NULL)
		free(pobj->name);
	for (i = 0; i < SPLITCOUNT; i++) {
		objectRelease(pobj->out_data[i]);
	}
	objectRelease(pobj->in);
	objectRelease(pobj->in_data);
	memset(pobj, 0, sizeof(sHDL4SESplit4));
	free(pobj);
}

static int hdl4se_split4Valid(HOBJECT object)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	return 1;
}

static int hdl4se_split4_hdl4se_unit_Connect(HOBJECT object, int index, HOBJECT from, int fromindex) 
{
	sHDL4SESplit4* pobj;
	IHDL4SEUnit** unit = NULL;
	pobj = (sHDL4SESplit4*)objectThis(object);
	if (index == 0) {
		if (0 == objectQueryInterface(from, IID_HDL4SEUNIT, (void**)&unit)) {
			objectRelease(pobj->in);
			pobj->in = unit;
			pobj->in_index = fromindex;
		}
		else {
			return -2;
		}
	}
	else {
		return -1;
	}
	return 0;
}

static int hdl4se_split4_hdl4se_unit_GetValue(HOBJECT object, int index, int width, IBigNumber** value)
{
	int i;
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	if (index < 1 || index > SPLITCOUNT)
		return -1;
	if (pobj->datavalid == 0) {
		objectCall3(pobj->in, GetValue, pobj->in_index, pobj->width, pobj->in_data);
		pobj->datavalid = 1;
		for (i = 0; i < SPLITCOUNT; i++) {
			objectCall3(pobj->out_data[i], AssignSubBits, pobj->in_data, pobj->out_info[i][1], pobj->out_info[i][0]);
		}
		pobj->datavalid = 1;
	}
	objectCall1(value, Assign, pobj->out_data[index-1]);
	return 0;
}

static int hdl4se_split4_hdl4se_unit_ClkTick(HOBJECT object)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	return 0;
}

static int hdl4se_split4_hdl4se_unit_Setup(HOBJECT object)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	pobj->datavalid = 0;
	return 0;
}

static int hdl4se_split4_hdl4se_detector_GetName(HOBJECT object, const char** pname)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	*pname = pobj->name;
	return 0;
}

static int hdl4se_split4_hdl4se_detector_GetSignalCount(HOBJECT object)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	return SPLITCOUNT + 1;
}

static const char* outname[SPLITCOUNT] = {
	"out0", "out1", "out2", "out3"
};

static int hdl4se_split4_hdl4se_detector_GetSignalInfo(HOBJECT object, int index, const char** pname, int *width)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	if (index <0 || index > SPLITCOUNT)
		return -1;
	if (index == 0) {
		*pname = "in";
		*width = pobj->width;
	}
	else {
		*pname = outname[index - 1];
		*width = pobj->out_info[index - 1][0];
	}
	return 0;
}

static int hdl4se_split4_hdl4se_detector_GetSignalValue(HOBJECT object, int index, IBigNumber** value)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	if (index <0 || index > SPLITCOUNT)
		return -1;
	if (index == 0)
		return objectCall3(pobj->in, GetValue, pobj->in_index, pobj->width, pobj->in_data);
	else
		return hdl4se_split4_hdl4se_unit_GetValue(object, index, pobj->out_info[index - 1][0], value);
	return 0;
}

static int hdl4se_split4_hdl4se_detector_GetUnitCount(HOBJECT object)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	return 0;
}

static int hdl4se_split4_hdl4se_detector_GetUnit(HOBJECT object, int index, HOBJECT* unit)
{
	sHDL4SESplit4* pobj;
	pobj = (sHDL4SESplit4*)objectThis(object);
	return 0;
}
